
        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        .LIST

;###############################################################################################

        .DATA

ClassName db 'SmallWindowClass',0
AppName   db 'Small Window',0

;------------------------------

        .DATA?

        ALIGN   4

hInstance dd ?
hWin      dd ?

;###############################################################################################

        .CODE

        ALIGN   16

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     ecx,uMsg
        cmp     ecx,WM_DESTROY
        jz      WndPrZ

;------------------------------

;unhandled messages come here

;the return address and 4 parms are already on the stack
;if you push EBX, EBP, ESI, or EDI, be sure to pop them

        leave
        JMP     DefWindowProc

;------------------------------

;exit with 0

WndPr0: xor     eax,eax
        ret

;------------------------------

;WM_DESTROY

WndPrZ: INVOKE  PostQuitMessage,NULL
        jmp     WndPr0

WndProc ENDP

;***********************************************************************************************

_main   PROC

;------------------------------

;EDI is zero throughout the entire _main proc

        xor     edi,edi

;------------------------------

;register the class for the window

;we create the WNDCLASSEX structure on the stack by pushing members in reverse
;the same stack space is later used for the message loop MSG structure

        INVOKE  LoadIcon,edi,IDI_APPLICATION
        push    eax                                     ;WNDCLASSEX.hIconSm
        xchg    eax,ebx                                                           ;save hIcon in EBX for later
        mov     esi,offset ClassName                                              ;ClassName address in ESI
        push    esi                                     ;WNDCLASSEX.lpszClassName
        push    edi                                     ;WNDCLASSEX.lpszMenuName
        push    COLOR_SCROLLBAR+1                       ;WNDCLASSEX.hbrBackground
        INVOKE  LoadCursor,edi,IDC_ARROW
        push    eax                                     ;WNDCLASSEX.hCursor
        push    ebx                                     ;WNDCLASSEX.hIcon
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        push    eax                                     ;WNDCLASSEX.hInstance
        xchg    eax,ebx                                                           ;now, EBX = hInstance
        push    edi                                     ;WNDCLASSEX.cbWndExtra
        push    edi                                     ;WNDCLASSEX.cbClsExtra
        push    WndProc                                 ;WNDCLASSEX.lpfnWndProc
        push    edi                                     ;WNDCLASSEX.style
        push    sizeof WNDCLASSEX                       ;WNDCLASSEX.cbSize
        INVOKE  RegisterClassEx,esp

;------------------------------

;create the window

;the window size will be 400x300
;by using CW_USEDEFAULT for the x position, the OS chooses the screen position for you
;this is the simplest way if you want to allow multiple instances of the application
;the OS will cascade them for you - they do not sit right on top of each other
;it also allows you to control the initial show state in the y position parm
;in this case, we want a hidden window, so we use SW_HIDE

        INVOKE  CreateWindowEx,edi,esi,offset AppName,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,
                CW_USEDEFAULT,SW_HIDE,400,300,edi,edi,ebx,edi
        mov     hWin,eax
        INVOKE  UpdateWindow,eax

;------------------------------

;message loop

        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage,esp
        INVOKE  DispatchMessage,esp

mLoop1: mov     eax,esp
        INVOKE  GetMessage,eax,edi,edi,edi
        neg     eax                                ;exit only
        shr     eax,1                              ;if 0 or -1
        jnz     mLoop0                             ;otherwise, we loop

;------------------------------

;exit program

        pop     eax                                ;adjust the stack so that MSG.wParam is the parm for ExitProcess
        JMP     ExitProcess

_main   ENDP

;###############################################################################################

        END     _main

